﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using STDTO.DataTransferObjects.Base;
using STDTO.DataTransferObjects.Unit.Tests.Interfaces;
using System.Runtime.Serialization;
using STDTO.DataTransferObjects.Interfaces;
using Microsoft.Practices.Unity;

namespace STDTO.DataTransferObjects.Unit.Tests.DTOs
{
    [DataContract]
    public class ObjectContainsSimpleObjectDto : UnitySelfTrackingDataTransferObjectBase<IObjectContainsSimpleObject>, IObjectContainsSimpleObject
    {
        public ObjectContainsSimpleObjectDto(IUnityContainer unityContainer) : base(unityContainer) { }
        #region ISimpleObject Members
        [DataMember]
        private int _Id;
        [DataMember]
        private ISimpleObject _SimpleObject;
   

        public int Id
        {
            get
            {
                return _Id;
            }
            set
            {
                Set("Id", ref _Id, value);
            }
        }

       
        public ISimpleObject SimpleObject
        {
            get
            {
                return _SimpleObject;
            }
            set
            {
                Set("SimpleObject", ref _SimpleObject, value); ;
            }
        }

        #endregion

        protected override void SpecificPopulate(IObjectContainsSimpleObject entity, IDataTrasferObjectToEntityMapper dataTrasferObjectToEntityMapper)
        {
            _Id = entity.Id;
            _SimpleObject = CreateDtoInner<ISimpleObject>(entity.SimpleObject, dataTrasferObjectToEntityMapper);
            
        }

        protected override void SpecificGetValue(IObjectContainsSimpleObject entity, bool getOriginalValue, IDataTrasferObjectToEntityMapper dataTrasferObjectToEntityMapper)
        {
            entity.Id = RetrievePropertyValue<int>("Id", getOriginalValue);
            entity.SimpleObject = ((ISelfTrackingDataTransferObjectEx<ISimpleObject>)SimpleObject).Clone(getOriginalValue, dataTrasferObjectToEntityMapper);
            
        }

        protected override void SpecificApplyChanges(IObjectContainsSimpleObject entity, IDataTrasferObjectToEntityMapper dataTrasferObjectToEntityMapper)
        {
            ((ISelfTrackingDataTransferObjectEx<ISimpleObject>)SimpleObject).ApplyChanges(entity.SimpleObject, dataTrasferObjectToEntityMapper);
        }	 
    }
}
